/*LINTLIBRARY*/

/*
** Based on code provided by Robert Elz, who writes:
**	The "best" way to do mktime I think is based on an idea of Bob
**	Kridle's (so its said...) from a long time ago. (mtxinu!kridle now).
**	It does a binary search of the time_t space.  Since time_t's are
**	just 32 bits, its a max of 32 iterations (even at 64 bits it
**	would still be very reasonable).
*/

#include "sys/types.h"
#include "time.h"

#ifndef WRONG
#define WRONG	(-1)
#endif /* !defined WRONG */

time_t
mktime(timeptr)
struct tm *	timeptr;
{
	register int	direction;
	register int	bits;
	time_t		t;
	struct tm	yourtm, mytm;

	yourtm = *timeptr;
	/*
	** Calculate the number of magnitude bits in a time_t
	** (this works regardless of whether time_t is
	** signed or unsigned, though lint complains if unsigned).
	*/
	for (bits = 0, t = 1; t > 0; ++bits, t <<= 1)
		;
	/*
	** If time_t is signed, then 0 is the median value,
	** if time_t is unsigned, then 1 << bits is median.
	*/
	t = (t < 0) ? 0 : ((time_t) 1 << bits);
	for ( ; ; ) {
		mytm = *gmtime(&t);
		if ((direction = (mytm.tm_year - yourtm.tm_year)) == 0 &&
			(direction = (mytm.tm_mon - yourtm.tm_mon)) == 0 &&
			(direction = (mytm.tm_mday - yourtm.tm_mday)) == 0 &&
			(direction = (mytm.tm_hour - yourtm.tm_hour)) == 0 &&
			(direction = (mytm.tm_min - yourtm.tm_min)) == 0)
				direction = mytm.tm_sec - yourtm.tm_sec;
		if (direction == 0) {
			*timeptr = mytm;
			return t;
		}
		if (bits-- < 0) {
			*timeptr = yourtm;	/* restore "original" value */
			return WRONG;
		}
		if (bits < 0)
			--t;
		else if (direction > 0)
			t -= (time_t) 1 << bits;
		else	t += (time_t) 1 << bits;
	}
}

